package pl.soppo.ucwizard.model 
{
	import org.robotlegs.mvcs.Actor;
	import pl.soppo.ucwizard.model.data.IconData;
	import pl.soppo.ucwizard.model.data.ProjectData;
	import pl.soppo.ucwizard.controler.events.ListUpdateEvent;
	
	/**
	 * ...
	 * @author Maciej Reichwald
	 */
	public class ProjectModel extends Actor
	{
		private var _projectList:Array;
		private var _currentProject:int = 0;
		private var _languages:Array = new Array("English");
		private var _skins:Vector.<IconData>;
		
		public function get projectList():Array
		{
			return _projectList;
		}
		
		public function addNewProject(newProject:ProjectData):void
		{
			if ( projectList.length > 0 )
			{
				if( _projectList.length < 10 )
					_projectList.push( new ProjectData("") );
			
				for (var i:int = _projectList.length - 2; i >= 0;  i--)
					_projectList[i + 1] = _projectList[i];
			
				_projectList[0] = newProject;
			}
			else 
			{
				_projectList.push(newProject);
			}
			
			dispatch(new ListUpdateEvent(ListUpdateEvent.PROJECT_LIST_UPDATED));
		}
		
		public function addSkin(skin:IconData):void
		{
			var wasntThere:Boolean = true;
			for (var i:int = 0; i < skins.length; i++)
				if ( _skins[i].url == skin.url )
				{
					_skins[i] = skin;
					wasntThere = false;
					break;
				}
				
			if ( wasntThere ) 
			{
				_skins.push(skin);
				if (_skins.length > 7)
				{
					
				}
			}
		}
		
		public function set projectList(value:Array):void 
		{
			_projectList = value;
		}
		
		public function get currentProject():int 
		{
			return _currentProject;
		}
		
		public function set currentProject(value:int):void 
		{
			_currentProject = value;
		}
		
		public function get languages():Array 
		{
			return _languages;
		}
		
		public function get skins():Vector.<IconData> 
		{
			if ( _skins == null )
				_skins = new Vector.<IconData>();
			return _skins;
		}
		
		public function set skins(value:Vector.<IconData>):void 
		{
			_skins = value;
		}
	}

}