package pl.soppo.ucwizard.model.mediators 
{
	import flash.events.Event;
	import org.robotlegs.mvcs.Mediator;
	import pl.soppo.ucwizard.controler.events.BrowseDestinationEvent;
	import pl.soppo.ucwizard.controler.events.ChangedMenuEvent;
	import pl.soppo.ucwizard.model.data.GenerateData;
	import pl.soppo.ucwizard.model.data.ProjectData;
	import pl.soppo.ucwizard.model.ProjectModel;
	import pl.soppo.ucwizard.view.GenerateFormView;
	
	/**
	 * ...
	 * @author Maciej Reichwald
	 */
	public class GenerateFormViewMediator extends Mediator 
	{
		[Inject]
		public var projectModel:ProjectModel;
		
		[Inject]
		public var view:GenerateFormView;
		
		override public function onRegister():void
		{
			addViewListener(GenerateFormView.BROWSE_CLICK, handleBrowseClick);
			addContextListener( BrowseDestinationEvent.BROWSE_RESPONSE, handleBrowseResponse );
			
			addContextListener(ChangedMenuEvent.PROJECT_CHANGED, onProjectChanged);
			onProjectChanged();
		}
		
		private function onProjectChanged(e:Event=null):void 
		{
			if ( (projectModel.projectList[projectModel.currentProject] as ProjectData).generate.destinationFolder.url == "")
				(projectModel.projectList[projectModel.currentProject] as ProjectData).generate = new GenerateData();
			view.restoreDeafult((projectModel.projectList[projectModel.currentProject] as ProjectData).generate.destinationFolder.url);
		}
		
		private function handleBrowseResponse(e:BrowseDestinationEvent):void 
		{
			(projectModel.projectList[projectModel.currentProject] as ProjectData).generate.destinationFolder = e.file;
			view.setBrowseInput(e.file.url);
		}
		
		private function handleBrowseClick(e:Event):void 
		{
			dispatch( new BrowseDestinationEvent(BrowseDestinationEvent.BROWSE) );
		}
		
		
	}

}