package pl.soppo.ucwizard.model.mediators 
{
	import flash.events.Event;
	import mx.managers.PopUpManager;
	import org.robotlegs.mvcs.Mediator;
	import pl.soppo.ucwizard.controler.events.ChangedMenuEvent;
	import pl.soppo.ucwizard.model.FormViewModel;
	import pl.soppo.ucwizard.view.GeneratePopupView;
	
	/**
	 * ...
	 * @author Maciej Reichwald
	 */
	public class GeneratePopupViewMediator extends Mediator 
	{
		[Inject]
		public var view:GeneratePopupView;
		
		[Inject]
		public var formViewModel:FormViewModel;
		
		override public function onRegister():void
		{
			view.setUpView(
				"Create Application",
				"Are you sure that all settings are correct?"
				);
				
			addViewListener(GeneratePopupView.POPUP_EXIT, handleExit);
			addViewListener(GeneratePopupView.POPUP_CANCEL, handleExit);
			addViewListener(GeneratePopupView.POPUP_CREATE, handleCreate);
		}
		
		private function handleCreate(e:Event):void 
		{
			handleExit();
			dispatch( new ChangedMenuEvent(ChangedMenuEvent.CHANGED, formViewModel.currentForm + 1))
		}
		
		private function handleExit(e:Event=null):void 
		{
			PopUpManager.removePopUp(view);
			mediatorMap.removeMediator(this);
		}
		
	}

}