package pl.soppo.ucwizard.model.mediators 
{
	import flash.events.Event;
	import mx.managers.PopUpManager;
	import org.robotlegs.mvcs.Mediator;
	import flash.events.IEventDispatcher;
	import pl.soppo.ucwizard.controler.commands.EditProjectListCommand;
	import pl.soppo.ucwizard.controler.events.ChangedMenuEvent;
	import pl.soppo.ucwizard.controler.events.GenerateApplicationEvent;
	import pl.soppo.ucwizard.controler.events.GUIButtonEvent;
	import pl.soppo.ucwizard.controler.events.ListEditEvent;
	import pl.soppo.ucwizard.controler.events.ValidatedFormEvent;
	import pl.soppo.ucwizard.model.FormViewModel;
	import pl.soppo.ucwizard.Main;
	import pl.soppo.ucwizard.model.data.Globals;
	import pl.soppo.ucwizard.view.GeneratePopupView;
	
	/**
	 * ...
	 * @author Maciej Reichwald
	 */
	public class MainMediator extends Mediator 
	{
		[Inject]
		public var view:Main;
		
		[Inject]
		public var formViewModel:FormViewModel;
		
		override public function onRegister():void
		{
			addContextListener(ChangedMenuEvent.CHANGED, handleMenuChanged);
			addContextListener(ValidatedFormEvent.VALIDATED_FORM, handleValidateForm);
			addContextListener(GenerateApplicationEvent.GENERATE_APP, handleGenerateStart);
			addContextListener(GenerateApplicationEvent.GENERATE_END, handleGenerateEnd);
			
			addViewListener( Main.BACK_FORM, handleBackClick );
			addViewListener( Main.NEXT_FORM, handleNextClick );
		}
		
		private function handleGenerateEnd(e:GenerateApplicationEvent):void 
		{
			view.changeFormView(0, formViewModel.formViews);
			formViewModel.currentForm = 0;
		}
		
		private function handleGenerateStart(e:GenerateApplicationEvent):void 
		{
			view.setBack(false);
		}
		
		private function handleValidateForm(e:ValidatedFormEvent):void 
		{
			view.onValidatedMenu(e.isValid, formViewModel.currentForm >= formViewModel.formViews.length-1);
		}
		
		private function handleMenuChanged(e:ChangedMenuEvent):void 
		{
			view.changeFormView(e.menuNumber, formViewModel.formViews);
			formViewModel.currentForm = e.menuNumber;
		}
		
		private function handleBackClick(e:Event):void 
		{
			dispatch( new ChangedMenuEvent(ChangedMenuEvent.CHANGED, formViewModel.currentForm - 1));
			dispatch( new ListEditEvent( ListEditEvent.PROJECT_LIST_EDIT, Globals.PROJECTS_XML_PATH, null ) );
		}
		
		private function handleNextClick(e:Event):void 
		{
			dispatch( new ListEditEvent( ListEditEvent.PROJECT_LIST_EDIT, Globals.PROJECTS_XML_PATH, null ) );
			if ( formViewModel.currentForm + 1 == formViewModel.formViews.length - 1 )
			{
				var popup:GeneratePopupView = new GeneratePopupView();
				PopUpManager.addPopUp(popup, view, true);
				PopUpManager.bringToFront(popup);
				PopUpManager.centerPopUp(popup);
				mediatorMap.createMediator(popup);
			}
			else dispatch( new ChangedMenuEvent(ChangedMenuEvent.CHANGED, formViewModel.currentForm + 1));
		}
	}

}