package pl.soppo.ucwizard.view.contexts 
{
	import flash.display.DisplayObjectContainer;
	import org.robotlegs.mvcs.Context;
	import pl.soppo.ucwizard.model.*;
	import pl.soppo.ucwizard.view.*;
	import pl.soppo.ucwizard.service.*;
	import pl.soppo.ucwizard.model.mediators.*;
	import pl.soppo.ucwizard.service.parsers.*;
	import pl.soppo.ucwizard.Main;
	import pl.soppo.ucwizard.controler.events.*;
	import pl.soppo.ucwizard.controler.commands.*;
	/**
	 * ...
	 * @author Maciej Reichwald
	 */
	public class MainContext extends Context 
	{
		override public function startup():void
		{
			injector.mapSingleton(FormViewModel);
			
			injector.mapSingleton(LoadProjectXMLService);
			injector.mapSingleton(ProjectModel);
			injector.mapSingleton(ProjectXMLParser);
			injector.mapSingleton(SaveProjectXMLService);
			
			injector.mapSingleton(ChapterModel );
			injector.mapSingleton(LoadChapterXMLService );
			injector.mapSingleton(UpdateChapterXMLService );
			injector.mapSingleton(ChapterXMLParser );
			
			injector.mapSingleton(LoadGUIImageService);
			injector.mapSingleton(LoadByBrowseService);
			
			injector.mapSingleton(LoadDestinationFolderService);
			injector.mapSingleton(ApplicationGeneratorService);
			injector.mapSingleton(AppConfParser);
			
			mediatorMap.mapView(Main, MainMediator);
			mediatorMap.mapView(MainMenuView, MainMenuViewMediator);
			
			mediatorMap.mapView(NewProjectWindowView, NewProjectWindowViewMediator, null, false, false);
			mediatorMap.mapView(StartFormView, StartFormViewMediator);
			mediatorMap.mapView(GeneralFormView, GeneralFormViewMediator);
			mediatorMap.mapView(CourseFormView, CourseFormViewMediator);
			mediatorMap.mapView(GraphicsFormView, GraphicsFormViewMediator);
			mediatorMap.mapView(TranslationsFormView, TranslationsFormViewMediator);
			mediatorMap.mapView(InstallerFormView, InstallerFormViewMediator);
			mediatorMap.mapView(GenerateFormView, GenerateFormViewMediator);
			mediatorMap.mapView(GeneratePopupView, GeneratePopupViewMediator, null, false, false);
			mediatorMap.mapView(GenerationResultPopupView, GenerationResultPopupViewMediator, null, false, false);
			mediatorMap.mapView(ProgressFormView, ProgressFormViewMediator);
			
			commandMap.mapEvent(ListInitEvent.PROJECT_LIST_INIT, InitProjectListCommand, ListInitEvent);
			commandMap.mapEvent(ListEditEvent.PROJECT_LIST_EDIT, EditProjectListCommand, ListEditEvent);
			commandMap.mapEvent(ListInitEvent.CHAPTER_LIST_INIT, InitChapterListCommand, ListInitEvent );
			commandMap.mapEvent(ListUpdateEvent.CHAPTER_LIST_SOURCE_UPDATED, UpdateChapterListCommand, ListUpdateEvent );
			commandMap.mapEvent(GUIButtonEvent.BUTTON_ICON_LOAD, InitGUIObjectCommand, GUIButtonEvent );
			commandMap.mapEvent(InitGUIIconEvent.SKIN_LIST_INIT, UpdateByBrowseCommand, InitGUIIconEvent);
			commandMap.mapEvent(InitGUIIconEvent.ICON_CS_INIT, UpdateByBrowseCommand, InitGUIIconEvent);
			commandMap.mapEvent(BrowseDestinationEvent.BROWSE, BrowseDesinationCommand, BrowseDestinationEvent);
			commandMap.mapEvent(GenerateApplicationEvent.GENERATE_APP, GenerateApplicationCommand, GenerateApplicationEvent);
		}
	}

}
